Index: orxonox/branches/updater/src/gui/Makefile.in
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.in	(revision 3258)
+++ orxonox/branches/updater/src/gui/Makefile.in	(revision 3259)
@@ -228,7 +228,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/gui/Makefile
+	  $(AUTOMAKE) --foreign  src/gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3258)
+++ orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3259)
@@ -1186,7 +1186,7 @@
    \brief Sets the Total size of the Bar. (ex. The maximum one can download)
 */
-void setTotalSize (double totalSize)
-{
-  
+void ProgressBar::setTotalSize (double totalSize)
+{
+  this->totalSize = totalSize;
 }
 
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3258)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3259)
@@ -59,19 +59,10 @@
   updateWindow = new Window ("dampfen::update");   
   Window::addWindow(updateWindow);
-  
   updateWindowBox = new Box ('v');
 
-  updateData = new Button ("update orxonox::Data");
-
-#ifdef HAVE_GTK2 
-  updateData->connectSignal("button_press_event", updateData, updateDataFunc);
-#endif /* HAVE_GTK2 */
-  updateWindowBox->fill (updateData);
-
-  updateSource = new Button ("update orxonox::Source");
-#ifdef HAVE_GTK2 
-  updateSource->connectSignal("button_press_event", updateData, updateSourceFunc);
-#endif /* HAVE_GTK2 */
-  updateWindowBox->fill (updateSource);
+  updateDataWindowCreate();
+  updateWindowBox->fill (updateDataWindowGetButton());
+  updateSourceWindowCreate();
+  updateWindowBox->fill (updateSourceWindowGetButton());
   
   // the close-Button of the Update Window.
@@ -103,4 +94,50 @@
 }
 
+void OrxonoxGuiUpdate::updateDataWindowCreate (void)
+{
+
+  updateData = new Button ("update orxonox::Data");
+
+#ifdef HAVE_GTK2 
+  updateData->connectSignal("button_press_event", updateData, updateDataFunc);
+#endif /* HAVE_GTK2 */
+  
+
+}
+
+Button* OrxonoxGuiUpdate::updateDataWindowGetButton(void)
+{
+  return updateData;
+}
+
+void OrxonoxGuiUpdate::updateSourceWindowCreate (void)
+{
+  // the button, that opens this Window.
+  updateSource = new Button ("update orxonox::Source");
+
+  // the Window itself
+  updateSourceWindow = new Window ("update orxonox::Source");
+  updateSourceWindow->connectSignal("destroy", updateSourceWindow, Window::windowClose);
+  updateSourceWindow->connectSignal("delete_event", updateSourceWindow, Window::windowClose);
+
+  updateSourceWindowBox = new Box ();
+
+  updateSourceBar = new ProgressBar ();
+  updateSourceWindowBox->fill(updateSourceBar);
+  test = new Button ("increment");
+  test->connectSignal("button_press_event", updateSourceBar, updateSourceFunc);
+  updateSourceWindowBox->fill(test);
+  updateSourceWindow->fill(updateSourceWindowBox);
+#ifdef HAVE_GTK2 
+  updateSource->connectSignal("button_press_event", updateSourceWindow, Window::windowOpen);
+#endif /* HAVE_GTK2 */
+
+}
+
+Button* OrxonoxGuiUpdate::updateSourceWindowGetButton(void)
+{
+  return updateSource;
+}
+
 
 #ifdef HAVE_GTK2 
@@ -122,7 +159,9 @@
    \param button The Button, that triggered this event.
 */
-gint OrxonoxGuiUpdate::updateSourceFunc(GtkWidget* w, GdkEventKey* event, void* button)
+gint OrxonoxGuiUpdate::updateSourceFunc(GtkWidget* w, GdkEventKey* event, void* bar)
 {
-
+  ProgressBar* tmpBar = static_cast<ProgressBar*>(bar);
+  tmpBar->setTotalSize(20);
+  tmpBar->setProgress(tmpBar->getProgress()+1);
 }
 
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.h
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3258)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3259)
@@ -17,5 +17,5 @@
   Frame* updateFrame;          //!< The Frame that holds the updateOptions.
   Box* updateBox;              //!< The Box that holds the updateOptions.
-
+  
   Button* updateWindowButton;  //!< The Button that opens the update Window.
   Window* updateWindow;        //!< A Window to update orxonox.
@@ -24,8 +24,17 @@
   Button* updateSource;        //!< A Button to update the Source of orxonox. \todo tricky
   Button* updateWindowClose;   //!< A Button to Close the update Window
+  ProgressBar* updateDataBar;  //!< A Bar to display the progress of the download.
+  ProgressBar* updateSourceBar;//!< A Bar to display the progress of the download.
+  Window* updateDataWindow;    //!< A Window for the data-update.
 
+
+  Window* updateSourceWindow;  //!< A Window for the Source-update.
+  Box* updateSourceWindowBox;  //!< A Box for the Window for the Source-update.
+
+  Button* test;  //!< will be deleted soon.
+  
 #ifdef HAVE_GTK2 
-  static gint updateDataFunc (GtkWidget* w, GdkEventKey* event, void* button);
-  static gint updateSourceFunc (GtkWidget* w, GdkEventKey* event, void* button);
+  static gint updateDataFunc (GtkWidget* w, GdkEventKey* event, void* bar);
+  static gint updateSourceFunc (GtkWidget* w, GdkEventKey* event, void* bar);
 #endif /* HAVE_GTK2 */
 
@@ -40,4 +49,9 @@
   Button* updateWindowGetButton(void);
 
+  void updateDataWindowCreate (void);
+  Button* updateDataWindowGetButton(void);
+
+  void updateSourceWindowCreate (void);
+  Button* updateSourceWindowGetButton(void);
 };
 