Index: /orxonox/branches/updater/Makefile.in
===================================================================
--- /orxonox/branches/updater/Makefile.in	(revision 3261)
+++ /orxonox/branches/updater/Makefile.in	(revision 3262)
@@ -102,8 +102,12 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
+GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
+GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
+HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
+HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@
Index: /orxonox/branches/updater/configure
===================================================================
--- /orxonox/branches/updater/configure	(revision 3261)
+++ /orxonox/branches/updater/configure	(revision 3262)
@@ -312,5 +312,5 @@
 #endif"
 
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK SET_MAKE am__leading_dot CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP DEBUG DOXYGEN DOXYGEN_TRUE DOXYGEN_FALSE MSBITFIELDS GTK2_LIBS GTK2_CFLAGS HAVE_GTK2_TRUE HAVE_GTK2_FALSE CURL_LIBS CURL_CFLAGS HAVE_CURL_TRUE HAVE_CURL_FALSE LIBOBJS LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK SET_MAKE am__leading_dot CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP DEBUG DOXYGEN DOXYGEN_TRUE DOXYGEN_FALSE MSBITFIELDS GTK2_LIBS GTK2_CFLAGS HAVE_GTK2_TRUE HAVE_GTK2_FALSE GTHREAD_LIBS GTHREAD_CFLAGS HAVE_GTHREAD_TRUE HAVE_GTHREAD_FALSE CURL_LIBS CURL_CFLAGS HAVE_CURL_TRUE HAVE_CURL_FALSE LIBOBJS LTLIBOBJS'
 ac_subst_files=''
 
@@ -872,4 +872,5 @@
   --without-PACKAGE       do not use PACKAGE (same as --with-PACKAGE=no)
   --without-gtk           Prevents GTK from being loaded
+  --without-gthread       Prevents gThread from being loaded
   --without-curl          Prevents libcURL from being loaded
   --without-sdl-image     Prevents SDL_image from being loaded
@@ -3887,4 +3888,22 @@
 fi
 
+## gThread-disabled
+echo "$as_me:$LINENO: checking if gThread should be enabled" >&5
+echo $ECHO_N "checking if gThread should be enabled... $ECHO_C" >&6
+
+# Check whether --with-gthread or --without-gthread was given.
+if test "${with_gthread+set}" = set; then
+  withval="$with_gthread"
+  def_gthread=no
+else
+  def_gthread=yes
+fi;
+if test "$def_gthread" = yes; then
+  echo "yes"
+fi
+if test "$def_gthread" = no; then
+  echo "no"
+fi
+
 ## libCurl disabled?
 echo "$as_me:$LINENO: checking if libcURL should be enabled" >&5
@@ -6672,4 +6691,37 @@
 
 
+## checking for gThread
+if test "$def_gthread" = yes; then
+
+	echo "$as_me:$LINENO: checking for gthread" >&5
+echo $ECHO_N "checking for gthread... $ECHO_C" >&6
+	if `pkg-config --exists gthread`; then
+  		echo "yes"
+  		have_gthread=yes
+		GTHREAD_LIBS=`pkg-config --libs gthread`
+		GTHREAD_CFLAGS=`pkg-config --cflags gthread`
+
+cat >>confdefs.h <<_ACEOF
+#define HAVE_GTHREAD 1
+_ACEOF
+
+	else
+		echo "no"
+	fi
+
+fi
+
+
+
+
+if test x$have_gthread = xyes; then
+  HAVE_GTHREAD_TRUE=
+  HAVE_GTHREAD_FALSE='#'
+else
+  HAVE_GTHREAD_TRUE='#'
+  HAVE_GTHREAD_FALSE=
+fi
+
+
 ## checking for libcURL
 if test "$def_curl" = yes; then
@@ -7935,4 +7987,11 @@
 Usually this means the macro was only invoked conditionally." >&5
 echo "$as_me: error: conditional \"HAVE_GTK2\" was never defined.
+Usually this means the macro was only invoked conditionally." >&2;}
+   { (exit 1); exit 1; }; }
+fi
+if test -z "${HAVE_GTHREAD_TRUE}" && test -z "${HAVE_GTHREAD_FALSE}"; then
+  { { echo "$as_me:$LINENO: error: conditional \"HAVE_GTHREAD\" was never defined.
+Usually this means the macro was only invoked conditionally." >&5
+echo "$as_me: error: conditional \"HAVE_GTHREAD\" was never defined.
 Usually this means the macro was only invoked conditionally." >&2;}
    { (exit 1); exit 1; }; }
@@ -8546,4 +8605,8 @@
 s,@HAVE_GTK2_TRUE@,$HAVE_GTK2_TRUE,;t t
 s,@HAVE_GTK2_FALSE@,$HAVE_GTK2_FALSE,;t t
+s,@GTHREAD_LIBS@,$GTHREAD_LIBS,;t t
+s,@GTHREAD_CFLAGS@,$GTHREAD_CFLAGS,;t t
+s,@HAVE_GTHREAD_TRUE@,$HAVE_GTHREAD_TRUE,;t t
+s,@HAVE_GTHREAD_FALSE@,$HAVE_GTHREAD_FALSE,;t t
 s,@CURL_LIBS@,$CURL_LIBS,;t t
 s,@CURL_CFLAGS@,$CURL_CFLAGS,;t t
Index: /orxonox/branches/updater/configure.ac
===================================================================
--- /orxonox/branches/updater/configure.ac	(revision 3261)
+++ /orxonox/branches/updater/configure.ac	(revision 3262)
@@ -53,4 +53,16 @@
 fi 
 if test "$def_gtk" = no; then 
+  echo "no"
+fi
+
+## gThread-disabled
+AC_MSG_CHECKING([if gThread should be enabled])
+AC_ARG_WITH([gthread], 
+	AC_HELP_STRING(	[--without-gthread], 
+	[Prevents gThread from being loaded]), [def_gthread=no], [def_gthread=yes]) 
+if test "$def_gthread" = yes; then 
+  echo "yes"
+fi 
+if test "$def_gthread" = no; then 
   echo "no"
 fi
@@ -352,4 +364,23 @@
 AM_CONDITIONAL(HAVE_GTK2, test x$have_gtk2 = xyes)
 
+## checking for gThread
+if test "$def_gthread" = yes; then 
+
+	AC_MSG_CHECKING([for gthread])
+	if `pkg-config --exists gthread`; then
+  		echo "yes"
+  		have_gthread=yes
+		GTHREAD_LIBS=`pkg-config --libs gthread`
+		GTHREAD_CFLAGS=`pkg-config --cflags gthread`
+		AC_DEFINE_UNQUOTED(HAVE_GTHREAD, 1, [if we have gThread])
+	else
+		echo "no"
+	fi
+
+fi
+AC_SUBST(GTHREAD_LIBS)
+AC_SUBST(GTHREAD_CFLAGS)
+AM_CONDITIONAL(HAVE_GTHREAD, test x$have_gthread = xyes)
+
 ## checking for libcURL
 if test "$def_curl" = yes; then 
Index: /orxonox/branches/updater/src/Makefile.in
===================================================================
--- /orxonox/branches/updater/src/Makefile.in	(revision 3261)
+++ /orxonox/branches/updater/src/Makefile.in	(revision 3262)
@@ -127,8 +127,12 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
+GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
+GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
+HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
+HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@
Index: /orxonox/branches/updater/src/console/Makefile.in
===================================================================
--- /orxonox/branches/updater/src/console/Makefile.in	(revision 3261)
+++ /orxonox/branches/updater/src/console/Makefile.in	(revision 3262)
@@ -104,8 +104,12 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
+GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
+GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
+HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
+HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@
Index: /orxonox/branches/updater/src/debug.h
===================================================================
--- /orxonox/branches/updater/src/debug.h	(revision 3261)
+++ /orxonox/branches/updater/src/debug.h	(revision 3262)
@@ -1,4 +1,6 @@
 #ifndef _DEBUG_H
 #define _DEBUG_H
+
+#include <stdio.h>
 
 #ifdef  DEBUG
Index: /orxonox/branches/updater/src/gui/Makefile.am
===================================================================
--- /orxonox/branches/updater/src/gui/Makefile.am	(revision 3261)
+++ /orxonox/branches/updater/src/gui/Makefile.am	(revision 3262)
@@ -1,5 +1,5 @@
-AM_CXXFLAGS=$(GTK2_CFLAGS) $(MSBITFIELDS)
-#AM_LDFLAGS=$(GTK2_LIBS)
-LIBS=$(GTK2_LIBS)
+AM_CXXFLAGS=$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+#AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
+LIBS=$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 
 bin_PROGRAMS=gui
Index: /orxonox/branches/updater/src/gui/Makefile.in
===================================================================
--- /orxonox/branches/updater/src/gui/Makefile.in	(revision 3261)
+++ /orxonox/branches/updater/src/gui/Makefile.in	(revision 3262)
@@ -113,8 +113,12 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
+GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
+GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
+HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
+HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@
@@ -125,6 +129,6 @@
 LDFLAGS = @LDFLAGS@
 LIBOBJS = @LIBOBJS@
-#AM_LDFLAGS=$(GTK2_LIBS)
-LIBS = $(GTK2_LIBS)
+#AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
+LIBS = $(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
@@ -184,5 +188,5 @@
 target_os = @target_os@
 target_vendor = @target_vendor@
-AM_CXXFLAGS = $(GTK2_CFLAGS) $(MSBITFIELDS)
+AM_CXXFLAGS = $(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
 gui_SOURCES = orxonox_gui.cc \
 	    orxonox_gui_gtk.cc \
Index: /orxonox/branches/updater/src/importer/Makefile.in
===================================================================
--- /orxonox/branches/updater/src/importer/Makefile.in	(revision 3261)
+++ /orxonox/branches/updater/src/importer/Makefile.in	(revision 3262)
@@ -105,8 +105,12 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
+GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
+GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
+HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
+HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@