Index: orxonox/branches/updater/src/gui/Makefile.am
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.am	(revision 3267)
+++ orxonox/branches/updater/src/gui/Makefile.am	(revision 3268)
@@ -1,5 +1,5 @@
-AM_CXXFLAGS=$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
-#AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
-LIBS=$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+AM_CXXFLAGS=$(GTK2_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+#AM_LDFLAGS=$(GTK2_LIBS)
+LIBS=$(GTK2_LIBS) $(CURL_LIBS)
 
 bin_PROGRAMS=gui
Index: orxonox/branches/updater/src/gui/Makefile.in
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.in	(revision 3267)
+++ orxonox/branches/updater/src/gui/Makefile.in	(revision 3268)
@@ -113,12 +113,8 @@
 EGREP = @EGREP@
 EXEEXT = @EXEEXT@
-GTHREAD_CFLAGS = @GTHREAD_CFLAGS@
-GTHREAD_LIBS = @GTHREAD_LIBS@
 GTK2_CFLAGS = @GTK2_CFLAGS@
 GTK2_LIBS = @GTK2_LIBS@
 HAVE_CURL_FALSE = @HAVE_CURL_FALSE@
 HAVE_CURL_TRUE = @HAVE_CURL_TRUE@
-HAVE_GTHREAD_FALSE = @HAVE_GTHREAD_FALSE@
-HAVE_GTHREAD_TRUE = @HAVE_GTHREAD_TRUE@
 HAVE_GTK2_FALSE = @HAVE_GTK2_FALSE@
 HAVE_GTK2_TRUE = @HAVE_GTK2_TRUE@
@@ -129,6 +125,6 @@
 LDFLAGS = @LDFLAGS@
 LIBOBJS = @LIBOBJS@
-#AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
-LIBS = $(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+#AM_LDFLAGS=$(GTK2_LIBS)
+LIBS = $(GTK2_LIBS) $(CURL_LIBS)
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
@@ -188,5 +184,5 @@
 target_os = @target_os@
 target_vendor = @target_vendor@
-AM_CXXFLAGS = $(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+AM_CXXFLAGS = $(GTK2_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
 gui_SOURCES = orxonox_gui.cc \
 	    orxonox_gui_gtk.cc \
Index: orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3267)
+++ orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3268)
@@ -47,9 +47,4 @@
 bool initGTK(int argc, char *argv[])
 {
-#ifdef HAVE_GTHREAD
-  PRINTF(3)("Initializing the ThreadSystem of the GUI\n");
-  g_thread_init(NULL);
-  gdk_threads_init();
-#endif /* HAVE_GTHREAD */
   gtk_init (&argc, &argv);
   gtk_rc_parse( "rc" );
@@ -61,8 +56,6 @@
 bool mainloopGTK(void)
 {
-  gdk_threads_enter();
   PRINTF(1)("test\n");
   gtk_main();
-  gdk_threads_leave();
 }
 #endif /* HAVE_GTK2 */
@@ -1210,6 +1203,9 @@
     this->progress = this->totalSize;
 
+
 #ifdef HAVE_GTK2
   gtk_progress_set_value(GTK_PROGRESS(widget), this->progress*100.0/this->totalSize);
+  while (gtk_events_pending()) 
+    gtk_main_iteration_do(TRUE);
 #endif /* HAVE_GTK2 */
   PRINTF(3)("Progress: %f\n", progress*100.0/totalSize);
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3267)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3268)
@@ -158,14 +158,5 @@
   info->Bar = (ProgressBar*)bar;
   PRINTF(3)("Preparing to download file %s.\n", info->fileName);
-  //  downloadThread (info);
-
-  if (downloadThreadID == NULL)
-    {
-      if ( (downloadThreadID =g_thread_create(&downloadThread, info, TRUE, NULL)) == 0 )
-	PRINTF(1)("can't create the thread");
-    }
-  else 
-    PRINTF(1)("thread already in use\n");
-
+  download(info);
 }
 
@@ -198,15 +189,11 @@
 int OrxonoxGuiUpdate::curlProgressFunc (ProgressBar* Bar, double totalSize, double progress, double upTotal, double upProgress)
 {
-  gdk_threads_enter();
   Bar->setProgress(progress);
   Bar->setTotalSize(totalSize);
-  gdk_threads_leave();
   return 0;
-
-}
-
-GThread* OrxonoxGuiUpdate::downloadThreadID = NULL;
-
-void* OrxonoxGuiUpdate::downloadThread (void* fileInfo)
+}
+
+
+void* OrxonoxGuiUpdate::download (void* fileInfo)
 {
   
@@ -241,7 +228,12 @@
       curl_easy_cleanup(curl);
     }
-  downloadThreadID = NULL;
   return NULL;
 }
+
+#ifdef HAVE_GTK2
+gint OrxonoxGuiUpdate::cancelDownload(GtkWidget* w, GdkEventKey* event, void* bar)
+{
+}
+#endif /* HAVE_GTK2 */
 
 #endif /* HAVE_CURL */
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.h
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3267)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3268)
@@ -53,7 +53,8 @@
   static int curlProgressFunc (ProgressBar* Bar, double totalSize, double progress, double upTotal, double upProgress);
 
-  static GThread* downloadThreadID;
-  static void* downloadThread (void* fileInfo);
-  
+  static void* download (void* fileInfo);
+#ifdef HAVE_GTK2 
+  static gint cancelDownload(GtkWidget* w, GdkEventKey* event, void* bar);
+#endif /* HAVE_GTK2 */  
 #endif /* HAVE_CURL */
 