Index: orxonox/branches/updater/src/Makefile.in
===================================================================
--- orxonox/branches/updater/src/Makefile.in	(revision 3272)
+++ orxonox/branches/updater/src/Makefile.in	(revision 3273)
@@ -282,7 +282,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  src/Makefile
+	  $(AUTOMAKE) --gnu  src/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: orxonox/branches/updater/src/console/Makefile.in
===================================================================
--- orxonox/branches/updater/src/console/Makefile.in	(revision 3272)
+++ orxonox/branches/updater/src/console/Makefile.in	(revision 3273)
@@ -201,7 +201,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/console/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/console/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  src/console/Makefile
+	  $(AUTOMAKE) --gnu  src/console/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: orxonox/branches/updater/src/gui/Makefile.in
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.in	(revision 3272)
+++ orxonox/branches/updater/src/gui/Makefile.in	(revision 3273)
@@ -232,7 +232,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  src/gui/Makefile
+	  $(AUTOMAKE) --gnu  src/gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3272)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3273)
@@ -200,6 +200,11 @@
 }
 
+#ifdef HAVE_CURL
 CURL* OrxonoxGuiUpdate::curlHandle = NULL;
+#endif /* HAVE_CURL */
+
+#ifdef HAVE_PTHREAD_H
 pthread_t* OrxonoxGuiUpdate::downloadThreadID = new pthread_t;
+#endif /* HAVE_PTHREAD_H */
 bool OrxonoxGuiUpdate::isDownloading = false;
 
@@ -217,5 +222,5 @@
   strcpy (fileOnDisk, info->localRoot);
   strcat (fileOnDisk, info->fileName);
-  pthread_t test;
+
   if(curlHandle)
     {
@@ -234,5 +239,10 @@
 	{
 	  //! \todo check if threads really were created.
+#ifdef HAVE_PTHREAD_H
 	  pthread_create(downloadThreadID, NULL, downloadThread, info);
+#else
+	  downloadThread(info);
+#endif /* HAVE_PTHREAD_H */
+	 
 	  //      else 
 	  //	PRINTF(1)("thread already in use\n");
@@ -252,6 +262,7 @@
   if (curlHandle)
     curl_easy_cleanup(curlHandle);
-
+#ifdef HAVE_PTHREAD_H
   pthread_join(*downloadThreadID, NULL);
+#endif /* HAVE_PTHREAD_H */
   PRINTF(3)("Closing the downloaded file.\n");
   fclose(info->fileHandle);
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.h
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3272)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3273)
@@ -14,5 +14,7 @@
 #include <curl/easy.h>
 #endif /* HAVE_CURL */
+#ifdef HAVE_PTHREAD_H
 #include <pthread.h>
+#endif /* HAVE_PTHREAD_H */
 using namespace std;
 
@@ -64,5 +66,7 @@
   static gint cancelDownload(GtkWidget* w, GdkEventKey* event, void* bar);
 #endif /* HAVE_GTK2 */  
+#ifdef HAVE_PTHREAD_H
   static pthread_t* downloadThreadID;
+#endif /* HAVE_PTHREAD_H */
   static bool isDownloading;
 
Index: orxonox/branches/updater/src/importer/Makefile.in
===================================================================
--- orxonox/branches/updater/src/importer/Makefile.in	(revision 3272)
+++ orxonox/branches/updater/src/importer/Makefile.in	(revision 3273)
@@ -208,7 +208,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/importer/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/importer/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  src/importer/Makefile
+	  $(AUTOMAKE) --gnu  src/importer/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status