Index: orxonox/branches/old.dave/src/camera.cc
===================================================================
--- orxonox/branches/old.dave/src/camera.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/camera.cc	(revision 3279)
@@ -206,5 +206,5 @@
   // view
   // TO DO: implement options for frustum generation
-  glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 250.0);
+  glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 400.0);
   //Vector up(0,0,1);
   //Vector dir(1,0,0);
Index: orxonox/branches/old.dave/src/command_node.cc
===================================================================
--- orxonox/branches/old.dave/src/command_node.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/command_node.cc	(revision 3279)
@@ -183,5 +183,5 @@
 	  strcpy (cmd.cmd, aliases->keys[event.key.keysym.sym]);
 	  cmd.bUp = false;
-	 
+	  cmd.NumPressed+=1;
 	  
 	  if( strlen (cmd.cmd) > 0) relay (&cmd);
@@ -190,4 +190,5 @@
 	  strcpy( cmd.cmd, aliases->keys[event.key.keysym.sym]);
 	  cmd.bUp = true;
+	  cmd.NumPressed-=1;
 	  
 	 
Index: orxonox/branches/old.dave/src/message_structures.h
===================================================================
--- orxonox/branches/old.dave/src/message_structures.h	(revision 3278)
+++ orxonox/branches/old.dave/src/message_structures.h	(revision 3279)
@@ -11,5 +11,6 @@
 //! structure that contains a command message
 typedef struct
-{	float tottime;
+{	int NumPressed;
+	float tottime;
 	float rottime;
 	float angle;
Index: orxonox/branches/old.dave/src/orxonox.cc
===================================================================
--- orxonox/branches/old.dave/src/orxonox.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/orxonox.cc	(revision 3279)
@@ -135,7 +135,7 @@
   SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
   
-  int bpp = 16;
-  int width = 640;
-  int height = 480;
+  int bpp = 32;
+  int width = 1024;
+  int height = 768;
   Uint32 flags = SDL_HWSURFACE | SDL_OPENGL | SDL_GL_DOUBLEBUFFER;
   
Index: orxonox/branches/old.dave/src/player.cc
===================================================================
--- orxonox/branches/old.dave/src/player.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/player.cc	(revision 3279)
@@ -28,5 +28,7 @@
 
   obj = new Object ("reaplow.obj");
+  numPressed=0;
   tottime=0.0f;
+  numPressed=0;
   movfinishright=movfinishleft=movfinishup=movfinishdown=false;
   angleturn=false;
@@ -95,8 +97,12 @@
 {
   //printf("Player|recieved command [%s]\n", cmd->cmd);
- 
-  tottime=cmd->tottime;
+  numPressed=cmd->NumPressed;
+  
   rottime=cmd->rottime;
-  angleturn=cmd->angleturn;
+  if(numPressed<1){
+	tottime=cmd->tottime;
+	angleturn=cmd->angleturn;
+  }
+  
   
   
@@ -208,11 +214,11 @@
   if( bDown) { accel = accel-(direction*acceleration*pow(tottime,2.0f));movfinishdown=true;tottimecopy=tottime; }
   if( bLeft ) { accel = accel + (orthDirection*acceleration*pow(tottime,2.0f));
-	if(angle>-40.0f){
-	  angle=angle-rottime*40.0f;}
+	if(angle>-20.0f){
+	  angle=angle-rottime*20.0f;}
 	movfinishleft=true;
 	tottimecopy=tottime;}
   if( bRight ) { accel = accel - (orthDirection*acceleration*pow(tottime,2.0f));
-	if(angle<40.0f){
-	  angle=angle+rottime*40.0f;}
+	if(angle<20.0f){
+	  angle=angle+rottime*20.0f;}
 	  movfinishright=true;
 	  tottimecopy=tottime;
Index: orxonox/branches/old.dave/src/player.h
===================================================================
--- orxonox/branches/old.dave/src/player.h	(revision 3278)
+++ orxonox/branches/old.dave/src/player.h	(revision 3279)
@@ -44,4 +44,5 @@
   float rottime;
   float angle;
+  int numPressed;
   bool angleturn;
   bool movfinishright,movfinishleft,movfinishup,movfinishdown;
Index: orxonox/branches/old.dave/src/track.cc
===================================================================
--- orxonox/branches/old.dave/src/track.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/track.cc	(revision 3279)
@@ -76,5 +76,5 @@
   //	camplc->w = Quaternion (trace.a, Vector(0,0,1));
   float r = (lookat->dist)*PI / l;
-  camplc->r = trace.r + (trace.a * ((lookat->dist-10.0) / l)) + Vector(0,0,5.0);
+  camplc->r = trace.r + (trace.a * ((lookat->dist-18.0) / l)) + Vector(0,0,12.0);
   
   Vector w(0.0,0.0,0.0);
Index: orxonox/branches/old.dave/src/world.cc
===================================================================
--- orxonox/branches/old.dave/src/world.cc	(revision 3278)
+++ orxonox/branches/old.dave/src/world.cc	(revision 3279)
@@ -343,5 +343,5 @@
       
     }
-  */  
+    
   //draw track
   glBegin(GL_LINES);
@@ -352,6 +352,7 @@
       glVertex3f(pathnodes[(i+1)%tracklen].x,pathnodes[(i+1)%tracklen].y,pathnodes[(i+1)%tracklen].z);
     }
-  glEnd();
+  glEnd();*/
   glEndList();
+  
 }
 